#!/bin/sh
# install.sh
#
#
#
# Please actually read the README for once in your life!!  :-)
# 
#

clear
echo -e "\033[3;035m.....................................................................\033[0m"
echo "                                                                     "
echo "             Welcome to the pmfirewall setup script.                 "
echo -e "\033[3;035m.....................................................................\033[0m"
echo ""

# WELL ARE YOU ROOT?
if [ "$UID" != "0" ]
 then
   echo "Nice Try, The install script must be run as root"
   echo ""
   exit 1
fi


### ASK FOR CONFIG DIR
echo "You will now be prompted for your system configuration. Normally the"
echo "defaults are sufficient, but be sure they are correct!"
echo ""
printf "Directory to place config files [/usr/local/pmfirewall]: "
read CONFIG_DIR
if [ "$CONFIG_DIR" = "" ]
 then
   CONFIG_DIR=/usr/local/pmfirewall
fi
ABSPATH=`echo $CONFIG_DIR | grep "^/"`
if [ "$ABSPATH" = "" ]
 then
   echo "Config directory must be an absolute path"
   echo ""
   exit 2
fi
if [ ! -d $CONFIG_DIR ]
 then
   mkdir $CONFIG_DIR
   if [ $? != 0 ]
     then
       echo "ERROR: Failed to create directory $CONFIG_DIR"
       echo ""
     exit 2
  fi
fi
if [ -r "$CONFIG_DIR/pmfirewall.conf" ]
 then
  cp -f $CONFIG_DIR/pmfirewall.conf $CONFIG_DIR/pmfirewall.conf.bak
  echo "Making backup of existing config file"
  echo ""
fi


### ASK FOR LOCATION OF IPCHAINS
echo ""
echo "PMFirewall requires ipchains to run. Please enter the full path to"
echo "ipchains on your system."
echo ""
if [ -x /sbin/ipchains ]
 then
   IPCDEF=/sbin/ipchains
 else
  IPCDEF=""
fi
if [ "$IPCDEF" = "" ]
 then
   printf "Full path to ipchains: "
   read IPC
   if [ "$IPC" = "" ]
    then
      echo "ERROR: No path entered!"
      echo ""
    exit 4
  fi
 else
   printf "Full path to ipchains [$IPCDEF]: "
   read IPC
   if [ "$IPC" = "" ]
    then
      IPC=$IPCDEF
   fi
fi


### ASK FOR EXTERNAL INTERFACE
echo ""
echo "What is your External Interface?"
echo ""
printf "External Interface [eth0]: "
read OUTERIF
if [ "$OUTERIF" = "" ]
 then
   OUTERIF=eth0
fi
echo ""


### CREATE FIREWALL RULES
FWRULES=pmfirewall.rules.2
echo  "#!/bin/sh" > $FWRULES
echo  "# pmfirewall.rules.2 - used by pmfirewall package" >> $FWRULES
echo  "#" >> $FWRULES


### IS YOUR IP ASSIGNED VIA DHCP?
echo ""
printf "Is your IP address assigned via DHCP?  (y/n): "
read DHCPIPYORN
if [ "$DHCPIPYORN" = "y" -o "$DHCPIPYORN" = "Y" ]
 then
   echo '$IPCHAINS -A input -p udp -s $REMOTENET -d 255.255.255.255 67 -i $OUTERIF -j ACCEPT' >> $FWRULES
   echo '$IPCHAINS -A input -p udp -s $REMOTENET -d 255.255.255.255 68 -i $OUTERIF -j ACCEPT' >> $FWRULES
   DHCPIP=1
fi


### FTP?
echo ""
printf "Are you running a FTP Server on port: 21 (y/n): "
read FTPYORN
if [ "$FTPYORN" = "y" -o "$FTPYORN" = "Y" ]
 then
   echo '$IPCHAINS -A input -p tcp -s $REMOTENET -d $OUTERNET 20 -j ACCEPT' >> $FWRULES
   echo '$IPCHAINS -A input -p tcp -s $REMOTENET -d $OUTERNET 21 -j ACCEPT' >> $FWRULES
fi

### SSH?
echo ""
printf "Are you running a SSH Server on port: 22 (y/n): "
read SSHYORN
if [ "$SSHYORN" = "y" -o "$SSHYORN" = "Y" ]
 then
   echo '$IPCHAINS -A input -p tcp -s $REMOTENET -d $OUTERNET 22 -j ACCEPT' >> $FWRULES
fi

### TELNET?
echo ""
printf "Are you running a Telnet Server on port: 23 (y/n): "
read TELNETYORN
if [ "$TELNETYORN" = "y" -o "$TELNETYORN" = "Y" ]
 then
   echo '$IPCHAINS -A input -p tcp -s $REMOTENET -d $OUTERNET 23 -j ACCEPT' >> $FWRULES
fi

### SMTP?
echo ""
printf "Are you running a SMTP Server on port: 25 (y/n): "
read SMTPYORN
if [ "$SMTPYORN" = "y" -o "$SMTPYORN" = "Y" ]
 then
   echo '$IPCHAINS -A input -p tcp -s $REMOTENET -d $OUTERNET 25 -j ACCEPT' >> $FWRULES
fi

### DNS?
echo ""
printf "Are you running a DNS Server on port: 53 (y/n): "
read DNSYORN
if [ "$DNSYORN" = "y" -o "$DNSYORN" = "Y" ]
 then
   echo '$IPCHAINS -A input -p tcp -s $REMOTENET -d $OUTERNET 53 -j ACCEPT' >> $FWRULES
   echo '$IPCHAINS -A input -p udp -s $REMOTENET -d $OUTERNET 53 -j ACCEPT' >> $FWRULES
fi

### Webserver?
echo ""
printf "Are you running a Web Server on port: 80 (y/n): "
read WEBYORN
if [ "$WEBYORN" = "y" -o "$WEBYORN" = "Y" ]
 then
   echo '$IPCHAINS -A input -p tcp -s $REMOTENET -d $OUTERNET 80 -j ACCEPT' >> $FWRULES
fi

### POP?
echo ""
printf "Are you running a POP Server on port: 110 (y/n): "
read POPYORN
if [ "$POPYORN" = "y" -o "$POPYORN" = "Y" ]
 then
   echo '$IPCHAINS -A input -p tcp -s $REMOTENET -d $OUTERNET 110 -j ACCEPT' >> $FWRULES
fi

### IDENTD?
echo ""
printf "Allow IDENT connections on port: 113 (y/n): "
read IDENTYORN
if [ "$IDENTYORN" = "y" -o "$IDENTYORN" = "Y" ]
 then
   echo '$IPCHAINS -A input -p tcp -s $REMOTENET -d $OUTERNET 113 -j ACCEPT' >> $FWRULES
elif [ "$IDENTYORN" = "n" -o "$IDENTYORN" = "n" ]
 then
   echo '$IPCHAINS -A input -p tcp -s $REMOTENET -d $OUTERNET 113 -j REJECT' >> $FWRULES
fi

### NNTP?
echo ""
printf "Are you running a NNTP Server port: 119 (y/n): "
read NNTPYORN
if [ "$NNTPYORN" = "y" -o "$NNTPYORN" = "Y" ]
 then
   echo '$IPCHAINS -A input -p tcp -s $REMOTENET -d $OUTERNET 119 -j ACCEPT' >> $FWRULES
fi

### NTP?
echo ""
printf "Are you using NTP, it requires port: 123 (y/n): "
read NTPYORN
if [ "$NTPYORN" = "y" -o "$NTPYORN" = "Y" ]
 then
   echo '$IPCHAINS -A input -p tcp -s $REMOTENET -d $OUTERNET 123 -j ACCEPT' >> $FWRULES
   echo '$IPCHAINS -A input -p udp -s $REMOTENET -d $OUTERNET 123 -j ACCEPT' >> $FWRULES
fi

### IMAP?
echo ""
printf "Are you running an IMAP Server on port: 143 (y/n): "
read IMAPYORN
if [ "$IMAPYORN" = "y" -o "$IMAPYORN" = "Y" ]
 then
   echo '$IPCHAINS -A input -p tcp -s $REMOTENET -d $OUTERNET 143 -j ACCEPT' >> $FWRULES
fi

### SSL?
echo ""
printf "Are you running a SSL Web Server on port: 443 (y/n): "
read SSLYORN
if [ "$SSLYORN" = "y" -o "$SSLYORN" = "Y" ]
 then
   echo '$IPCHAINS -A input -p tcp -s $REMOTENET -d $OUTERNET 443 -j ACCEPT' >> $FWRULES
fi

### CUSTOM RULES?
echo ""
printf "Are there any other ports you wish to open to the outside? (y/n): "
read CUSTOMYORN
while [ "$CUSTOMYORN" = "y" -o "$CUSTOMYORN" = "Y" ]
 do
   echo "Please only enter one service at a time. This will repeat."
   printf "Port number: "
   read CUSTOMPORT
 until  [ "$CUSTOMPORT" -le "65535" ]
   do
    echo "Not a valid port, try again."
    printf "Port number: "
    read CUSTOMPORT
   done
  printf "tcp, udp or both: "
  read CUSTPROT
  if [ "$CUSTPROT" = "tcp" -o "$CUSTPROT" = "udp" -o "$CUSTPROT" = "TCP" -o "$CUSTPROT" = "UDP" ]
   then
     echo '$IPCHAINS -A input -p'" $CUSTPROT "'-s $REMOTENET -d $OUTERNET'" $CUSTOMPORT "'-j ACCEPT' >> $FWRULES
  elif  [ "$CUSTPROT" = "BOTH" -o "$CUSTPROT" = "both" ]
   then
     CUSTPROT=tcp
     CUSTPROT2=udp
     echo '$IPCHAINS -A input -p'" $CUSTPROT "'-s $REMOTENET -d $OUTERNET'" $CUSTOMPORT "'-j ACCEPT' >> $FWRULES
     echo '$IPCHAINS -A input -p'" $CUSTPROT2 "'-s $REMOTENET -d $OUTERNET'" $CUSTOMPORT "'-j ACCEPT' >> $FWRULES
   else
     echo "Not a valid protocol"
  fi
  printf "Do you wish to add others? (y/n): "
  read CUSTOMYORN
done


### START AT BOOT?
ATBOOT=0
echo ""
printf "Start PMFirewall on bootup (y/n): "
read ATBOOTYORN
if [ "$ATBOOTYORN" = "y" -o "$ATTBOOTYORN" = "Y" ]
 then
  ATBOOT=1
fi


### CREATE CONFIG FILE
CFILE=$CONFIG_DIR/pmfirewall.conf
echo '#!/bin/sh' > $CFILE
echo '# pmfirewall.conf - used by pmfirewall package' >> $CFILE
echo "IPCHAINS=$IPC" >> $CFILE
echo "ATBOOT=$ATBOOT" >> $CFILE
echo "CONFIG_DIR=$CONFIG_DIR" >> $CFILE
echo "OUTERIF=$OUTERIF" >> $CFILE
echo 'OUTERIP=`ifconfig $OUTERIF | grep inet | cut -d : -f 2 | cut -d \  -f 1`' >> $CFILE
echo 'OUTERMASK=`ifconfig $OUTERIF | grep Mask | cut -d : -f 4`' >> $CFILE
echo 'OUTERNET=$OUTERIP/$OUTERMASK' >> $CFILE
echo 'REMOTENET=0/0' >> $CFILE


### WILL THEY USE MASQUERADING?
MASQ=0
echo ""
printf "Will this box Masquerade connections for other PC's (y/n): "
read MASQYORN
if [ "$MASQYORN" = "y" -o "$MASQYORN" = "Y" ]
 then
   MASQ=1
fi
echo ""	
if [ "$MASQ" = "1" ]
 then
   ### ASK FOR INTERNAL INTERFACE
   INTERNALIF=""
   echo ""
   echo "What is your Internal Interface?"
   echo ""
    if [ "$OUTERIF" = "ppp0" ]; then
        printf "Internal Interface [eth0]: "
        read INTERNALIF
        if [ "$INTERNALIF" = "" ]; then
            INTERNALIF=eth0
        fi
    else
        printf "Internal Interface [eth1]: "
        read INTERNALIF
        if [ "$INTERNALIF" = "" ]; then
            INTERNALIF=eth1
        fi
    fi
   echo "INTERNALIF=$INTERNALIF" >> $CFILE
   echo 'INTERNALIP=`ifconfig $INTERNALIF | grep inet | cut -d : -f 2 | cut -d \  -f 1`' >> $CFILE
   echo 'INTERNALMASK=`ifconfig $INTERNALIF | grep Mask | cut -d : -f 4`' >> $CFILE
   echo 'INTERNALNET=$INTERNALIP/$INTERNALMASK' >> $CFILE
   echo ""
else 
   echo "Skipping masq configuration"
   echo ""
fi

if [ "$MASQ" = "1" ]
 then
  printf "Will you be running a DHCP Server (y/n): "
  read DHCPYORN
  if [ "$DHCPYORN" = "y" -o "$DHCPYORN" = "Y" ]
   then
   echo '$IPCHAINS -A input -p udp -s $REMOTENET 67 -i $INTERNALIF -j ACCEPT' >> $FWRULES
   echo '$IPCHAINS -A input -p udp -s $REMOTENET 68 -i $INTERNALIF -j ACCEPT' >> $FWRULES
  fi
  echo ""
fi


### CREATE pmfirewall CONTROL SCRIPT
CONTROLFILE=$CONFIG_DIR/pmfirewall 
echo '#!/bin/sh' > $CONTROLFILE
echo "# pmfirewall" >> $CONTROLFILE
echo "# description: Control script for pmfirewall package." >> $CONTROLFILE
echo "#"  >> $CONTROLFILE
echo ""  >> $CONTROLFILE
echo "CONFIG_DIR=$CONFIG_DIR" >> $CONTROLFILE
if [ -r "/etc/rc.d/init.d/functions" ]
 then
   echo "# Source function library."  >> $CONTROLFILE
   echo ". /etc/rc.d/init.d/functions"  >> $CONTROLFILE
fi
if [ "$MASQ" = "1" ]
 then
   cat pmfirewall.ctl.masq >> $CONTROLFILE
 else
   cat pmfirewall.ctl >> $CONTROLFILE
fi


### COPY FILES TO CONFIG DIR
echo -n "Copying files to $CONFIG_DIR"
cp -f pmfirewall.rules.1 $CONFIG_DIR/pmfirewall.rules.1
cp -f pmfirewall.rules.2 $CONFIG_DIR/pmfirewall.rules.2
cp -f pmfirewall.rules.masq  $CONFIG_DIR/pmfirewall.rules.masq
cp -f README $CONFIG_DIR/README.pmfirewall
cp -f IPCHAINS-HOWTO $CONFIG_DIR/IPCHAINS-HOWTO
if [  ! -f "$CONFIG_DIR/pmfirewall.rules.local" ]
 then
   cp -f pmfirewall.rules.local $CONFIG_DIR/pmfirewall.rules.local
fi
echo "			Done!"
echo ""
sleep 2


## CHANGE OWNERSHIP
echo -n "Changing ownership of pmfirewall to root:bin"
chown 0:0 $CONFIG_DIR/pmfirewall.rules.1
chown 0:0 $CONFIG_DIR/pmfirewall.rules.2
chown 0:0 $CONFIG_DIR/pmfirewall.rules.masq
chown 0:0 $CONFIG_DIR/pmfirewall.conf
chown 0:0 $CONFIG_DIR/pmfirewall
chown 0:0 $CONFIG_DIR/README.pmfirewall
chown 0:0 $CONFIG_DIR/pmfirewall.rules.local
echo "		Done!"
echo ""
sleep 2

# CHANGE PERMISSIONS
echo -n "Changing permissions of pmfirewall to 700"
chmod 700 $CONFIG_DIR/pmfirewall.rules.1
chmod 700 $CONFIG_DIR/pmfirewall.rules.2
chmod 700 $CONFIG_DIR/pmfirewall.rules.masq
chmod 700 $CONFIG_DIR/pmfirewall.rules.local
chmod 700 $CONFIG_DIR/pmfirewall.conf
chmod 700 $CONFIG_DIR/pmfirewall
echo "		Done!"
echo ""
sleep 2

## ADD AND SETUP init.d control files
if [ -d "/etc/rc.d/init.d/" ]
 then
  cp -f $CONTROLFILE /etc/rc.d/init.d/pmfirewall
  chown 0:0 /etc/rc.d/init.d/pmfirewall
  chmod 700  /etc/rc.d/init.d/pmfirewall
fi
if [ -d "/etc/init.d/" ]
 then
  cp -f $CONTROLFILE /etc/init.d/pmfirewall
  chown 0:0 /etc/init.d/pmfirewall
  chmod 700  /etc/init.d/pmfirewall
fi


### BOOT STARTUP CONFIGURE

if [ "$ATBOOT" = "1" ]
 then
  BOOTSET=1
fi

## Covers some with SYS V init (Redhat, Mandrake, OpenLinux, SuSE)
if [ "$ATBOOT" = "1"  -a -r "/etc/rc.d/init.d/pmfirewall" ]
 then
   echo "Adding to init structure at /etc/rc.d/init.d/"
   echo -n "Configuring to start at boot time"
   ln -sf /etc/rc.d/init.d/pmfirewall /etc/rc.d/rc0.d/K80pmfirewall
   ln -sf /etc/rc.d/init.d/pmfirewall /etc/rc.d/rc1.d/K80pmfirewall
   ln -sf /etc/rc.d/init.d/pmfirewall /etc/rc.d/rc2.d/S50pmfirewall
   ln -sf /etc/rc.d/init.d/pmfirewall /etc/rc.d/rc3.d/S50pmfirewall
   ln -sf /etc/rc.d/init.d/pmfirewall /etc/rc.d/rc4.d/S50pmfirewall
   ln -sf /etc/rc.d/init.d/pmfirewall /etc/rc.d/rc5.d/S50pmfirewall
   ln -sf /etc/rc.d/init.d/pmfirewall /etc/rc.d/rc6.d/K80pmfirewall
   echo "			Done!"
   echo ""
   BOOTSET=0
   sleep 2

## Covers some with SYS V init (Debian)
elif [ "$ATBOOT" = "1"  -a -r "/etc/init.d/pmfirewall" ]
 then
   echo "Adding to init structure at /etc/init.d/"
   echo -n "Configuring to start at boot time"
   ln -sf /etc/init.d/pmfirewall /etc/rc0.d/K80pmfirewall
   ln -sf /etc/init.d/pmfirewall /etc/rc1.d/K80pmfirewall
   ln -sf /etc/init.d/pmfirewall /etc/rc2.d/S50pmfirewall
   ln -sf /etc/init.d/pmfirewall /etc/rc3.d/S50pmfirewall
   ln -sf /etc/init.d/pmfirewall /etc/rc4.d/S50pmfirewall
   ln -sf /etc/init.d/pmfirewall /etc/rc5.d/S50pmfirewall
   ln -sf /etc/init.d/pmfirewall /etc/rc6.d/K80pmfirewall
   echo "			Done!"
   echo ""
   BOOTSET=0
   sleep 2

## Covers any with /etc/rc.d/rc.local (Slackware)
elif [ "$ATBOOT" = "1"  -a ! -d "/etc/rc.d/init.d/" -a -r "/etc/rc.d/rc.local" ]
 then
   echo "Adding to /etc/rc.d/rc.local"
   echo -n "Configuring to start at boot time"
   echo "" >> /etc/rc.d/rc.local
   echo "#Start PMFirewall" >> /etc/rc.d/rc.local
   echo "$CONFIG_DIR/pmfirewall start" >> /etc/rc.d/rc.local
   echo "			Done!"
   echo ""
   BOOTSET=0
   sleep 2

## Covers any with /etc/rc.local (unknown)
elif [ "$ATBOOT" = "1"  -a ! -d "/etc/init.d/" -a -r "/etc/rc.local" ]
 then
   echo "Adding to /etc/rc.local"
   echo -n "Configuring to start at boot time"
   echo "" >> /etc/rc.local
   echo "#Start PMFirewall" >> /etc/rc.local
   echo "$CONFIG_DIR/pmfirewall start" >> /etc/rc.local
   echo "			Done!"
   echo ""
   BOOTSET=0
   sleep 2
fi

## UNABLE TO START AT BOOT
if [ "$BOOTSET" = "1" ]
 then
   echo "Unable to automatically start at boot."
   echo "Please add to bootup manually."
   echo ""
   sleep 2
fi

## PPP SETUP

if [ "$OUTERIF" = "ppp0" -a "$ATBOOT" = "1" ]
 then
  echo
  echo "Adding PMFirewall to PPP startup."
  if grep /etc/ppp/ip-up.local /etc/ppp/ip-up >/dev/null 2>&1
   then
    if [ ! -f /etc/ppp/ip-up.local ]
     then
       echo '#!/bin/sh' > /etc/ppp/ip-up.local
       chmod 755 /etc/ppp/ip-up.local
    fi
    if grep pmfirewall /etc/ppp/ip-up.local >/dev/null 2>&1
     then
       echo "PMFirewall entry found in /etc/ppp/ip-up.local."
       echo "ip-up.local will not be changed."
       echo ""
       sleep 2
     else
       echo "" >> /etc/ppp/ip-up.local
       echo "[ -x "$CONFIG_DIR/pmfirewall" ] && $CONFIG_DIR/pmfirewall start" >> /etc/ppp/ip-up.local
       sleep 2
    fi
   else
     echo "Unable to start upon PPP activation." 
     echo "Please start manually after each connection."
     echo ""
     sleep 2
  fi
fi

### DCHP SETUP
if [ "$DHCPIP" = "1" -a "$ATBOOT" = "1" ]
 then
  echo ""
  echo "Starting DCHP Setup."
  if [ ! -d /etc/dhcpc/ ]
   then
    mkdir /etc/dhcpc/
  fi
  if [ ! -f /etc/dhcpc/dhcpcd-$OUTERIF.exe ]
   then
     echo '#!/bin/sh' > /etc/dhcpc/dhcpcd-$OUTERIF.exe
     chmod 755 /etc/dhcpc/dhcpcd-$OUTERIF.exe
  fi
  if grep $CONFIG_DIR/pmfirewall /etc/dhcpc/dhcpcd-$OUTERIF.exe >/dev/null 2>&1
   then
     echo "PMFirewall entry found in /etc/dhcpc/dhcpcd-$OUTERIF.exe."
     echo "dhcpcd-$OUTERIF.exe will not be changed."
     echo ""
     DHCPIP=0
     sleep 2
   else
     echo "" >> /etc/dhcpc/dhcpcd-$OUTERIF.exe
     echo "[ -x "$CONFIG_DIR/pmfirewall" ] && $CONFIG_DIR/pmfirewall start" >> /etc/dhcpc/dhcpcd-$OUTERIF.exe
     echo "Adding PMFirewall entry to /etc/dhcpc/dhcpcd-$OUTERIF.exe."
     echo ""
     DHCPIP=0
     sleep 2
  fi
fi

if [ "$DHCPIP" = "1" ]; then
   echo "Unable to add PMFirewall to DHCP Startup." 
   echo "Please start manually after each new IP assignment."
   echo ""
   sleep 2
fi

if [ "$ATBOOT" = "0" ]
 then
   echo "Skipping startup configuration."
   echo ""
   sleep 2
fi

# REMOVE MISTAKE :)
rm -f /pmfirewall >/dev/null 2>&1
rm -f /etc/rc.d/rc2.d/S15pmfirewall >/dev/null 2>&1
rm -f /etc/rc.d/rc3.d/S15pmfirewall >/dev/null 2>&1
rm -f /etc/rc.d/rc4.d/S15pmfirewall >/dev/null 2>&1
rm -f /etc/rc.d/rc5.d/S15pmfirewall >/dev/null 2>&1
rm -f /etc/rc2.d/S15pmfirewall >/dev/null 2>&1
rm -f /etc/rc3.d/S15pmfirewall >/dev/null 2>&1
rm -f /etc/rc4.d/S15pmfirewall >/dev/null 2>&1
rm -f /etc/rc5.d/S15pmfirewall >/dev/null 2>&1

echo -e "\a"
echo -e "\033[3;035m.......................................................................\033[0m"
echo ""
echo "        PMFirewall has been successfully installed!      "
echo "        Configuration Directory: $CONFIG_DIR "
echo ""      
echo "        To enable/disable PMFirewall type:   "      
echo ""      
if [ "$MASQ" = "1" ]
 then
   echo " $CONFIG_DIR/pmfirewall {start|stop|restart|masqstart|masqstop}   "      
else
  echo "      $CONFIG_DIR/pmfirewall {start|stop|restart}   "      
fi
echo ""      
echo "        Please visit http://www.pointman.org"      
echo "            for updates and information. "     
echo ""
echo "                  Best Regards,"
echo ""
echo "                         Rick Johnson <rick@pointman.org>"
echo ""
echo -e "\033[3;035m.......................................................................\033[0m"
echo ""

# EOF

